<template>
  <InfoBox title="Dividendenturbo">
    <template slot="header-action">
      Apple (WKN: 865985)
    </template>
    <ul class="flex my-2">
      <li v-for="selection in corridorSelection" :key="selection.length" class="mr-4">
        <input :id="selection.intervalLength" v-model="intervalLength" type="radio" :value="selection.intervalLength">
        <label :for="selection.intervalLength">{{ selection.label }}</label>
      </li>
    </ul>
    <client-only>
      <ApexChart
        type="area"
        :options="options"
        :series="series"
      />
    </client-only>
  </InfoBox>
</template>

<script lang="ts">
import Vue from 'vue';
import { format } from 'date-fns';
import { dividendTimeSeries } from '../assets/js/mockData';

// Number of data points that will be shown in the diagram.
const numberOfDividendValues = 36;

export default Vue.extend({
  data () {
    return {
      corridorSelection: [{
        intervalLength: 12,
        label: '12 Monats-Korridor'
      }, {
        intervalLength: 24,
        label: '2 Jahres-Korridor'
      }, {
        intervalLength: 60,
        label: '5 Jahres Korridor'
      }],
      intervalLength: 12
    };
  },

  computed: {
    activeCorridorLabel () {
      return ((this as any).corridorSelection.find((item: any) => item.intervalLength === this.intervalLength) || {}).label.replace('-Korridor', '') || '12 Monats';
    },

    dividendTurboValue () {
      return dividendTimeSeries.map((seriesItem: any, index: number) => {
        const startIndex = index - (this as any).intervalLength < 0
          ? 0
          : index - (this as any).intervalLength;
        const numberOfValues = index - startIndex;

        const averageYield =
          dividendTimeSeries
            .slice(startIndex, index)
            .map(item => item.yield)
            .reduce((item: number, accumulator: number) => {
              return accumulator + item;
            }, 0) / numberOfValues;

        return {
          ...seriesItem,
          averageYield,
          averageYieldMin: averageYield * 0.8,
          averageYieldMax: averageYield * 1.2
        };
      });
    },

    options () {
      const startIndex = dividendTimeSeries.length - numberOfDividendValues < 0
        ? 0
        : dividendTimeSeries.length - numberOfDividendValues;

      return {
        chart: {
          animations: {
            enabled: false
          },
          zoom: {
            enabled: true,
            autoScaleYaxis: true
          },
          toolbar: {
            show: false
          },
          stacked: false
        },
        legend: {
          show: false
        },
        grid: {
          position: 'front'
        },
        stroke: {
          width: [1, 2, 1, 1, 1],
          curve: 'smooth',
          dashArray: [0, 0, 0, 0, 5]
        },
        plotOptions: {
          bar: {
            columnWidth: '30%'
          }
        },
        dataLabels: {
          enabled: false
        },
        // TODO
        // Comment in this section if you have forecast data and want to
        // show it in the diagram.
        //
        // forecastDataPoints: {
        //   count: 3,
        //   fillOpacity: 0.1,
        //   strokeWidth: 1,
        //   dashArray: 2
        // },
        colors: ['#54a4f0', '#5aa7ef', '#ebf4fc', '#ebf4fc', '#b2d4f4'],
        fill: {
          colors: ['#54a4f0', '#5aa7ef', '#ebf4fc', '#ffffff', '#b2d4f4'],
          opacity: [1, 1, 1, 1, 1],
          type: ['solid', 'solid', 'solid', 'solid', 'solid'],
          pattern: [undefined, {
            style: 'squares',
            width: 6,
            height: 6,
            strokeWidth: 10
          }]
        },
        labels:
          (this as any).dividendTurboValue
            .map((item: any) => format(item.date, 'MM/dd/yyyy'))
            .slice(startIndex, startIndex + numberOfDividendValues),
        markers: {
          size: 0
        },
        xaxis: {
          type: 'datetime'
        },
        yaxis: [{
          title: {
            text: 'Dividenden'
          },
          opposite: true,
          min: 0,
          max: 25,
          tickAmount: 5,
          axisBorder: {
            show: true,
            color: 'black',
            offsetX: -5,
            offsetY: 0
          },
          axisTicks: {
            show: true,
            borderType: 'solid',
            color: 'black',
            width: 6,
            offsetX: 0,
            offsetY: 0
          }
        }, {
          title: {
            text: 'Dividentenrendite in %'
          },
          min: 0,
          max: 4,
          tickAmount: 4
        }, {
          show: false,
          min: 0,
          max: 4
        }, {
          show: false,
          min: 0,
          max: 4
        }, {
          show: false,
          min: 0,
          max: 4
        }],
        tooltip: {
          y: {
            formatter: (y: any, { dataPointIndex, series, seriesIndex }: any) => {
              if (typeof y !== 'undefined') {
                if (seriesIndex === 0) {
                  return y.toFixed(2) + '€';
                } else if (seriesIndex === 2) {
                  return null;
                } else if (seriesIndex === 3) {
                  return `${y.toFixed(1)}% - ${series[2][dataPointIndex]}%`;
                }
                return y.toFixed(1) + '%';
              }
              return y;
            }
          }
        }
      };
    },

    series () {
      // Always show the latest dividend values
      const startIndex = dividendTimeSeries.length - numberOfDividendValues < 0
        ? 0
        : dividendTimeSeries.length - numberOfDividendValues;

      return [{
        name: 'Dividende',
        type: 'column',
        data:
          (this as any).dividendTurboValue
            .map((item: any) => Number(item.value.toFixed(2)))
            .slice(startIndex, startIndex + numberOfDividendValues)
      }, {
        name: 'Dividendenrendite',
        type: 'line',
        data:
          (this as any).dividendTurboValue
            .map((item: any) => Number(item.yield.toFixed(2)))
            .slice(startIndex, startIndex + numberOfDividendValues)
      }, {
        name: 'Not used in legend (max yield value)',
        type: 'area',
        data:
          (this as any).dividendTurboValue
            .map((item: any) => Number(item.averageYieldMax.toFixed(2)))
            .slice(startIndex, startIndex + numberOfDividendValues)
      }, {
        name: `${(this as any).activeCorridorLabel}-Korridor`,
        type: 'area',
        data:
          (this as any).dividendTurboValue
            .map((item: any) => Number(item.averageYieldMin.toFixed(2)))
            .slice(startIndex, startIndex + numberOfDividendValues)
      }, {
        name: `${(this as any).activeCorridorLabel}-Mittelwert`,
        type: 'line',
        data:
          (this as any).dividendTurboValue
            .map((item: any) => Number(item.averageYield.toFixed(2)))
            .slice(startIndex, startIndex + numberOfDividendValues)
      }];
    }
  }
});
</script>
